/*******************************************************************
 *
 *    DESCRIPTION:	ata_atapi.h
 *
 *    AUTHOR:		Mark de Jong
 *
 *    HISTORY:    
 *
 *******************************************************************/

#ifndef ATA_ATAPI_H
#define ATA_ATAPI_H

unsigned int ata_atapi_init( ata_ide_info_type *ata_ide_info_trans );
unsigned int ata_atapi_execute_drive_diagnose( unsigned int drive );
unsigned int ata_atapi_identify_device( unsigned int drive, unsigned int *ata_data );
unsigned int ata_atapi_drive_door( unsigned int drive, unsigned int action );
unsigned int ata_atapi_get_sense( unsigned int drive, unsigned int *sense_key, unsigned int *asc, unsigned int *asc_q );
unsigned int ata_atapi_get_status( unsigned int drive, unsigned int *sense_key, unsigned int *asc, unsigned int *asc_q );
unsigned int ata_atapi_get_mech_status( unsigned int drive, unsigned int *mech_status );

void ata_atapi_select_device( unsigned int drive );
unsigned int ata_atapi_reset_device( unsigned int drive );
unsigned int ata_atap_set_slow_speed( unsigned int drive );

unsigned int ata_atapi_read_sector( unsigned int drive, unsigned long lba, unsigned long sector_count, unsigned int *ata_data );
unsigned int ata_atapi_read_sector_lba( unsigned int drive, unsigned long lba, unsigned long sector_count, unsigned int *ata_data );

unsigned int ata_atapi_read_TOC( unsigned int drive, unsigned int *ata_data );
unsigned int ata_atapi_read_CD_TEXT( unsigned int drive, unsigned int *ata_data );
unsigned int ata_atapi_read_DVD_structure( unsigned int drive, unsigned int *ata_data );

unsigned int ata_atapi_read_current_position( unsigned int drive, unsigned int *ata_data );

// Audio cd commands
unsigned int ata_atapi_start_scan( unsigned int drive, unsigned int direction, unsigned long start_time );
unsigned int ata_atapi_play_cd( unsigned int drive, unsigned long start_time, unsigned long end_time ); 
unsigned int ata_atapi_send_packet_command( unsigned int drive, unsigned int *command_buffer );

#endif // ATA_ATAPI_H
